
//expanding the HUD class so we can make changes
//this version is for normal DM matches
class shockDMHUD extends ChallengeHUD config(shockplHUD);

//selection of colors. Use as a template to make your own custom colors and add them
var color GreenColor, WhiteColor, GoldColor, BlueColor, LightCyanColor, SilverColor, BronzeColor, CyanColor, RedColor,
   LightGreenColor, DarkGreenColor, ParchmentColor, FrigginDarkColor;

//sets up the code to use the color you have set to true
var config bool UseGreenColor, UseWhiteColor, UseGoldColor, UseBlueColor, UseLightCyanColor, UseSilverColor, UseBronzeColor, 
	UseCyanColor, UseRedColor, UseLightGreenColor, UseDarkGreenColor, UseParchmentColor, UseFrigginDarkColor;

//tells the HUD what font size to use
var config bool UseSmallText, UseMediumText, UseLargeText, UseHugeText;

//changes the text
var config localized string MyLiveFeed;

//This is the master HUD rendering function. We are making small changes to a couple of spots so you can
// look for this:
//  "//change//"
//and you will find where I made my alterations.
simulated function PostRender( canvas Canvas )
{
   local float XL, YL, XPos, YPos, FadeValue;
   local string Message;
   local int M, i, j, k, XOverflow;
   local float OldOriginX;

   HUDSetup(canvas);
   if ( (PawnOwner == None) || (PlayerOwner.PlayerReplicationInfo == None) )
      return;

   if ( bShowInfo )
   {
      ServerInfo.RenderInfo( Canvas );
      return;
   }

   Canvas.Font = MyFonts.GetSmallFont( Canvas.ClipX );
   OldOriginX = Canvas.OrgX;
   // Master message short queue control loop.
   Canvas.Font = MyFonts.GetSmallFont( Canvas.ClipX );
   Canvas.StrLen("TEST", XL, YL);
   Canvas.SetClip(768*Scale - 10, Canvas.ClipY);
   bDrawFaceArea = false;
   if ( !bHideFaces && !PlayerOwner.bShowScores && !bForceScores && !bHideHUD
      && !PawnOwner.PlayerReplicationInfo.bIsSpectator && (Scale >= 0.4) )
   {
      DrawSpeechArea(Canvas, XL, YL);
      bDrawFaceArea = (FaceTexture != None) && (FaceTime > Level.TimeSeconds);
      if ( bDrawFaceArea )
      {
         if ( !bHideHUD && ((PawnOwner.PlayerReplicationInfo == None) || !PawnOwner.PlayerReplicationInfo.bIsSpectator) )
            Canvas.SetOrigin( FMax(YL*4 + 8, 70*Scale) + 7*Scale + 6 + FaceAreaOffset, Canvas.OrgY );
      }
   }

   for (i=0; i<4; i++)
   {
      if ( ShortMessageQueue[i].Message != None )
      {
         j++;

         if ( bResChanged || (ShortMessageQueue[i].XL == 0) )
         {
            if ( ShortMessageQueue[i].Message.Default.bComplexString )
               Canvas.StrLen(ShortMessageQueue[i].Message.Static.AssembleString(self,ShortMessageQueue[i].Switch,
                  ShortMessageQueue[i].RelatedPRI,ShortMessageQueue[i].StringMessage),ShortMessageQueue[i].XL, ShortMessageQueue[i].YL);
            else
               Canvas.StrLen(ShortMessageQueue[i].StringMessage, ShortMessageQueue[i].XL, ShortMessageQueue[i].YL);
            Canvas.StrLen("TEST", XL, YL);
            ShortMessageQueue[i].numLines = 1;
            if ( ShortMessageQueue[i].YL > YL )
            {
               ShortMessageQueue[i].numLines++;
               for (k=2; k<4-i; k++)
               {
                  if (ShortMessageQueue[i].YL > YL*k)
                     ShortMessageQueue[i].numLines++;
               }
            }
         }

         // Keep track of the amount of lines a message overflows, to offset the next message with.
         Canvas.SetPos(6, 2 + YL * YPos);
         YPos += ShortMessageQueue[i].numLines;
         if ( YPos > 4 )
            break;

         if ( ShortMessageQueue[i].Message.Default.bComplexString )
         {
            // Use this for string messages with multiple colors.
            ShortMessageQueue[i].Message.Static.RenderComplexMessage(Canvas,ShortMessageQueue[i].XL,  YL,
               ShortMessageQueue[i].StringMessage,ShortMessageQueue[i].Switch,ShortMessageQueue[i].RelatedPRI,
               None,ShortMessageQueue[i].OptionalObject);
         }
         else
         {
            Canvas.DrawColor = ShortMessageQueue[i].Message.Default.DrawColor;
            Canvas.DrawText(ShortMessageQueue[i].StringMessage, False);
         }
      }
   }

   Canvas.DrawColor = WhiteColor;
   Canvas.SetClip(OldClipX, Canvas.ClipY);
   Canvas.SetOrigin(OldOriginX, Canvas.OrgY);

   if ( PlayerOwner.bShowScores || bForceScores )
   {
      if ( (PlayerOwner.Scoring == None) && (PlayerOwner.ScoringType != None) )
         PlayerOwner.Scoring = Spawn(PlayerOwner.ScoringType, PlayerOwner);
      if ( PlayerOwner.Scoring != None )
      {
         PlayerOwner.Scoring.OwnerHUD = self;
         PlayerOwner.Scoring.ShowScores(Canvas);
         if ( PlayerOwner.Player.Console.bTyping )
            DrawTypingPrompt(Canvas, PlayerOwner.Player.Console);
         return;
      }
   }

   YPos = FMax(YL*4 + 8, 70*Scale);
   if ( bDrawFaceArea )
      DrawTalkFace( Canvas,0, YPos );
   if (j > 0)
   {
      bDrawMessageArea = True;
      MessageFadeCount = 2;
   }
   else
      bDrawMessageArea = False;

   if ( !bHideCenterMessages )
   {
      // Master localized message control loop.
      for (i=0; i<10; i++)
      {
         if (LocalMessages[i].Message != None)
         {
            if (LocalMessages[i].Message.Default.bFadeMessage && Level.bHighDetailMode)
            {
               Canvas.Style = ERenderStyle.STY_Translucent;
               FadeValue = (LocalMessages[i].EndOfLife - Level.TimeSeconds);
               if (FadeValue > 0.0)
               {
                  if ( bResChanged || (LocalMessages[i].XL == 0) )
                  {
                     if ( LocalMessages[i].Message.Static.GetFontSize(LocalMessages[i].Switch) == 1 )
                        LocalMessages[i].StringFont = MyFonts.GetBigFont( Canvas.ClipX );
                     else // ==2
                        LocalMessages[i].StringFont = MyFonts.GetHugeFont( Canvas.ClipX );
                     Canvas.Font = LocalMessages[i].StringFont;
                     Canvas.StrLen(LocalMessages[i].StringMessage, LocalMessages[i].XL, LocalMessages[i].YL);
                     LocalMessages[i].YPos = LocalMessages[i].Message.Static.GetOffset(LocalMessages[i].Switch, LocalMessages[i].YL, Canvas.ClipY);
                  }
                  Canvas.Font = LocalMessages[i].StringFont;
                  Canvas.DrawColor = LocalMessages[i].DrawColor * (FadeValue/LocalMessages[i].LifeTime);
                  Canvas.SetPos( 0.5 * (Canvas.ClipX - LocalMessages[i].XL), LocalMessages[i].YPos );
                  Canvas.DrawText( LocalMessages[i].StringMessage, False );
               }
            }
            else
            {
               if ( bResChanged || (LocalMessages[i].XL == 0) )
               {
                  if ( LocalMessages[i].Message.Static.GetFontSize(LocalMessages[i].Switch) == 1 )
                     LocalMessages[i].StringFont = MyFonts.GetBigFont( Canvas.ClipX );
                  else // == 2
                     LocalMessages[i].StringFont = MyFonts.GetHugeFont( Canvas.ClipX );
                  Canvas.Font = LocalMessages[i].StringFont;
                  Canvas.StrLen(LocalMessages[i].StringMessage, LocalMessages[i].XL, LocalMessages[i].YL);
                  LocalMessages[i].YPos = LocalMessages[i].Message.Static.GetOffset(LocalMessages[i].Switch, LocalMessages[i].YL, Canvas.ClipY);
               }
               Canvas.Font = LocalMessages[i].StringFont;
               Canvas.Style = ERenderStyle.STY_Normal;
               Canvas.DrawColor = LocalMessages[i].DrawColor;
               Canvas.SetPos( 0.5 * (Canvas.ClipX - LocalMessages[i].XL), LocalMessages[i].YPos );
               Canvas.DrawText( LocalMessages[i].StringMessage, False );
            }
         }
      }
   }
   Canvas.Style = ERenderStyle.STY_Normal;

   if ( !PlayerOwner.bBehindView && (PawnOwner.Weapon != None) && (Level.LevelAction == LEVACT_None) )
   {
      Canvas.DrawColor = WhiteColor;
      PawnOwner.Weapon.PostRender(Canvas);
      if ( !PawnOwner.Weapon.bOwnsCrossHair )
         DrawCrossHair(Canvas, 0,0 );
   }

   if ( (PawnOwner != Owner) && PawnOwner.bIsPlayer )
   {
   	//sets a default text size
      Canvas.Font = MyFonts.GetSmallFont( Canvas.ClipX );
      //Nah, let's choose another one
   	if(UseSmallText)
			Canvas.Font = MyFonts.GetSmallestFont( Canvas.ClipX );
		if(UseMediumText)
			Canvas.Font = MyFonts.GetSmallFont( Canvas.ClipX );
		if(UseLargeText)
			Canvas.Font = MyFonts.GetBigFont( Canvas.ClipX );
		if(UseHugeText)
			Canvas.Font=MyFonts.GetHugeFont(Canvas.ClipX);



      Canvas.bCenter = true;
      Canvas.Style = ERenderStyle.STY_Normal;
      //change//
      //Here is your blinking. By removing 'TutIconBlink' I stop the flashing
      //Canvas.DrawColor = CyanColor * TutIconBlink;
      
      //this sets a default in case false is returned on all the checks
      Canvas.DrawColor = CyanColor;
      
      //do we want to change the color?
      if(UseGreenColor)
      	Canvas.DrawColor = GreenColor;
		if(UseWhiteColor)
			Canvas.DrawColor = WhiteColor;
		if(UseGoldColor)
			Canvas.DrawColor = GoldColor;
		if(UseBlueColor)
			Canvas.DrawColor = BlueColor;
		if(UseLightCyanColor)
			Canvas.DrawColor = LightCyanColor;
		if(UseSilverColor)
			Canvas.DrawColor = SilverColor;
		if(UseBronzeColor)
			Canvas.DrawColor = BronzeColor;
		if(UseCyanColor)
			Canvas.DrawColor = CyanColor;
		if(UseRedColor)
			Canvas.DrawColor = RedColor;
		if(UseLightGreenColor)
			Canvas.DrawColor = LightGreenColor;
		if(UseDarkGreenColor)
			Canvas.DrawColor = DarkGreenColor;
		if(UseParchmentColor)
			Canvas.DrawColor = ParchmentColor;
		if(UseFrigginDarkColor)
			Canvas.DrawColor = FrigginDarkColor;

		//we picked our color and text size so lets draw it
      Canvas.SetPos(4, Canvas.ClipY - 96 * Scale);
      Canvas.DrawText( MyLiveFeed$PawnOwner.PlayerReplicationInfo.PlayerName, true );
      
      //this resets the canvas
      Canvas.bCenter = false;
      Canvas.DrawColor = WhiteColor;
      Canvas.Style = Style;
      Canvas.Font = MyFonts.GetSmallFont( Canvas.ClipX );
   }

   if ( bStartUpMessage && (Level.TimeSeconds < 5) )
   {
      bStartUpMessage = false;
      PlayerOwner.SetProgressTime(7);
   }
   if ( (PlayerOwner.ProgressTimeOut > Level.TimeSeconds) && !bHideCenterMessages )
      DisplayProgressMessage(Canvas);

   // Display MOTD
   if ( MOTDFadeOutTime > 0.0 )
      DrawMOTD(Canvas);
         
   if( !bHideHUD )
   {
      if ( !PawnOwner.PlayerReplicationInfo.bIsSpectator )
      {
         Canvas.Style = Style;

         // Draw Ammo
         if ( !bHideAmmo )
            DrawAmmo(Canvas);
            
         // Draw Health/Armor status
         DrawStatus(Canvas);

         // Display Weapons
         if ( !bHideAllWeapons )
            DrawWeapons(Canvas);
         else if ( Level.bHighDetailMode && (PawnOwner == PlayerOwner) && (PlayerOwner.Handedness == 2) )
         {
            // if weapon bar hidden and weapon hidden, draw weapon name when it changes
            if ( PawnOwner.PendingWeapon != None )
            {
               WeaponNameFade = 1.0;
               Canvas.Font = MyFonts.GetBigFont( Canvas.ClipX );
               Canvas.DrawColor = PawnOwner.PendingWeapon.NameColor;
               Canvas.SetPos(Canvas.ClipX - 360 * Scale, Canvas.ClipY - 64 * Scale);
               Canvas.DrawText(PawnOwner.PendingWeapon.ItemName, False);
            }
            else if ( (Level.NetMode == NM_Client) && PawnOwner.IsA('TournamentPlayer') && (TournamentPlayer(PawnOwner).ClientPending != None) )
            {
               WeaponNameFade = 1.0;
               Canvas.Font = MyFonts.GetBigFont( Canvas.ClipX );
               Canvas.DrawColor = TournamentPlayer(PawnOwner).ClientPending.NameColor;
               Canvas.SetPos(Canvas.ClipX - 360 * Scale, Canvas.ClipY - 64 * Scale);
               Canvas.DrawText(TournamentPlayer(PawnOwner).ClientPending.ItemName, False);
            }
            else if ( (WeaponNameFade > 0) && (PawnOwner.Weapon != None) )
            {
               Canvas.Font = MyFonts.GetBigFont( Canvas.ClipX );
               Canvas.DrawColor = PawnOwner.Weapon.NameColor;
               if ( WeaponNameFade < 1 )
                  Canvas.DrawColor = Canvas.DrawColor * WeaponNameFade;
               Canvas.SetPos(Canvas.ClipX - 360 * Scale, Canvas.ClipY - 64 * Scale);
               Canvas.DrawText(PawnOwner.Weapon.ItemName, False);
            }
         }
         // Display Frag count
         if ( !bAlwaysHideFrags && !bHideFrags )
            DrawFragCount(Canvas);
      }
      // Team Game Synopsis
      if ( !bHideTeamInfo )
         DrawGameSynopsis(Canvas);

      // Display Identification Info
      if ( PawnOwner == PlayerOwner )
         DrawIdentifyInfo(Canvas);

      if ( HUDMutator != None )
         HUDMutator.PostRender(Canvas);

      if ( (PlayerOwner.GameReplicationInfo != None) && (PlayerPawn(Owner).GameReplicationInfo.RemainingTime > 0) )
      {
         if ( TimeMessageClass == None )
            TimeMessageClass = class<CriticalEventPlus>(DynamicLoadObject("Botpack.TimeMessage", class'Class'));

         if ( (PlayerOwner.GameReplicationInfo.RemainingTime <= 300) && (PlayerOwner.GameReplicationInfo.RemainingTime != LastReportedTime) )
         {
            LastReportedTime = PlayerOwner.GameReplicationInfo.RemainingTime;
            if ( PlayerOwner.GameReplicationInfo.RemainingTime <= 30 )
            {
               bTimeValid = ( bTimeValid || (PlayerOwner.GameReplicationInfo.RemainingTime > 0) );
               if ( PlayerOwner.GameReplicationInfo.RemainingTime == 30 )
                  TellTime(5);
               else if ( bTimeValid && PlayerOwner.GameReplicationInfo.RemainingTime <= 10 )
                  TellTime(16 - PlayerOwner.GameReplicationInfo.RemainingTime);
            }
            else if ( PlayerOwner.GameReplicationInfo.RemainingTime % 60 == 0 )
            {
               M = PlayerOwner.GameReplicationInfo.RemainingTime/60;
               TellTime(5 - M);
            }
         }
      }
   }
   if ( PlayerOwner.Player.Console.bTyping )
      DrawTypingPrompt(Canvas, PlayerOwner.Player.Console);

   if ( PlayerOwner.bBadConnectionAlert && (PlayerOwner.Level.TimeSeconds > 5) )
   {
      Canvas.Style = ERenderStyle.STY_Normal;
      Canvas.DrawColor = WhiteColor;
      Canvas.SetPos(Canvas.ClipX - (64*Scale), Canvas.ClipY / 2);
      Canvas.DrawIcon(texture'DisconnectWarn', Scale);
   }
}

defaultproperties
{
	UseGreenColor=False
	UseWhiteColor=False
	UseGoldColor=True
	UseBlueColor=False
	UseLightCyanColor=False
	UseSilverColor=False
	UseBronzeColor=False
	UseCyanColor=False
	UseRedColor=False
	UseLightGreenColor=False
	UseDarkGreenColor=False
	UseParchmentColor=False
	UseFrigginDarkColor=False
	UseSmallText=False
	UseMediumText=True
	UseLargeText=False
	UseHugeText=False
	MyLiveFeed="Live Feed from "
   GreenColor=(R=0,G=255,B=0,A=0)
   WhiteColor=(R=255,G=255,B=255,A=0)
   GoldColor=(R=255,G=255,B=0,A=0)
   BlueColor=(R=0,G=0,B=255,A=0)
   LightCyanColor=(R=128,G=255,B=255,A=0)
   SilverColor=(R=138,G=164,B=166,A=0)
   BronzeColor=(R=203,G=147,B=52,A=0)
   CyanColor=(R=0,G=128,B=255,A=0)
   RedColor=(R=255,G=0,B=0,A=0)
   LightGreenColor=(R=0,G=136,B=0,A=0)
   DarkGreenColor=(R=0,G=255,B=128,A=0)
   ParchmentColor=(R=227,G=210,B=176,A=0)
   FrigginDarkColor=(R=4,G=4,B=4,A=0)
}